<template>
  <div class="column is-8-tablet is-offset-2-tablet is-6-desktop is-offset-3-desktop is-6-widescreen is-offset-3-widescreen is-4-fullhd is-offset-4-fullhd">
    <div class="column has-text-centered">
      <p class="title is-3">
        Create new account
      </p>
    </div>

    <div class="column">
      <SignupForm :processingSignup="processingSignup" :onValid="doSignup" />
    </div>

    <div class="column has-text-centered">
      <p class="subtitle is-5">
        Already have an account?
        <nuxt-link to="/login">
          Log in here
        </nuxt-link>
      </p>
    </div>
  </div>
</template>

<script>
import SignupForm from '~/components/SignupForm'

export default {
  auth: false,

  components: { SignupForm },

  data () {
    return {
      processingSignup: false
    }
  },

  methods: {
    doSignup ({ name, email, password }) {
      this.processingSignup = true

      const registrationInfo = { name, email, password }
      this.$axios.post('/signup', registrationInfo)
        .then(() => {
          this.$store.dispatch('snackbar/setSnackbar', { text: 'Registration successful', type: 'is-success' })
          this.$auth.loginWith('local', { data: registrationInfo })
            .then(() => {
              this.$store.dispatch('snackbar/setSnackbar', { text: 'Thank you for the registration ' + this.$auth.user.name, type: 'is-success' })
              this.$router.push('/')
            })
            .catch((error) => {
              try {
                if (error.response.data._error !== undefined) {
                  this.$store.dispatch('snackbar/setSnackbar', { text: error.response.data._error, type: 'is-danger' })
                } else {
                  this.$store.dispatch('snackbar/setSnackbar', { text: 'Invalid operation', type: 'is-danger' })
                }
              } catch {
                this.$store.dispatch('snackbar/setSnackbar', { text: 'Problem in signing in. Please try after sometime', type: 'is-danger' })
              }
              this.processingSignup = false
            })
        })
        .catch((error) => {
          try {
            if (error.response.data._error !== undefined) {
              this.$store.dispatch('snackbar/setSnackbar', { text: error.response.data._error, type: 'is-danger' })
            } else {
              this.$store.dispatch('snackbar/setSnackbar', { text: 'Invalid operation', type: 'is-danger' })
            }
          } catch {
            this.$store.dispatch('snackbar/setSnackbar', { text: 'Problem in registration. Please try after sometime', type: 'is-danger' })
          }
          this.processingSignup = false
        })
    }
  }
}
</script>
